package com.ejie.ab79.dao.actuaciones;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;
import javax.sql.DataSource;

import org.springframework.dao.support.DataAccessUtils;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.actuaciones.DesResAct;
import com.ejie.ab79.model.actuaciones.ResultadosActuacion;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.x38.dao.RowNumResultSetExtractor;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableManager;
import com.ejie.x38.dto.TableManagerJerarquia;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * ResultadosActuacionDaoImpl  
 * 
 *  
 */

@Repository
@Transactional
public class ResultadosActuacionDaoImpl implements ResultadosActuacionDao {

	public static final String[] ORDER_BY_WHITE_LIST = new String[] { "IDRESULTADOACTUACION",
			"RESULACTUACIONDESCCASTELLANO", "RESULACTUACIONDESCEUSKERA", "FECHAREGISTRO", "USUARIOREGISTRO",
			"DESNEUSORIGEN", "DESNESORIGEN", "DESNEUSDIREC", "DESNESDIREC", "IDORIGEN", "IDDIRECCION" };

	private JdbcTemplate jdbcTemplate;

	/*
	 * ROW_MAPPERS
	 */
	private RowMapper<ResultadosActuacion> rwMap = new RowMapper<ResultadosActuacion>() {
		public ResultadosActuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			ResultadosActuacion resultadosActuacion = new ResultadosActuacion();
			resultadosActuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));
			resultadosActuacion.setBaja(resultSet.getInt("BAJA"));
			resultadosActuacion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			resultadosActuacion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			DesResAct desResAct = new DesResAct();
			desResAct.setIdDesResAct(resultSet.getInt("IDDESRESACT"));
			desResAct.setDescripcionCastellano(resultSet.getString("RESULDESCRIPCIONCASTELLANO"));
			desResAct.setDescripcionEuskera(resultSet.getString("RESULDESCRIPCIONEUSKERA"));
			resultadosActuacion.setDesResAct(desResAct);

			OrigenesInspeccion origenInspeccionAux = new OrigenesInspeccion();
			origenInspeccionAux.setIdOrigenInspeccion(resultSet.getInt("IDORIGENINSPECCION"));
			resultadosActuacion.setOrigenesInspeccion(origenInspeccionAux);

			Direcciones direccionAux = new Direcciones();
			direccionAux.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			resultadosActuacion.setDireccion(direccionAux);

			return resultadosActuacion;
		}
	};

	private RowMapper<ResultadosActuacion> rwMapFindAll = new RowMapper<ResultadosActuacion>() {
		public ResultadosActuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			ResultadosActuacion resultadosActuacion = new ResultadosActuacion();

			resultadosActuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));
			resultadosActuacion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			resultadosActuacion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));
			resultadosActuacion.setBaja(resultSet.getInt("BAJA"));
			resultadosActuacion.setFechaUltmodificacion(resultSet.getDate("FECHAULTMODIFICACION"));
			resultadosActuacion.setUsuarioUltmodificacion(resultSet.getString("USUARIOULTMODIFICACION"));

			Direcciones direccion = new Direcciones();
			direccion.setIdDireccion(resultSet.getInt("IDDIRECCION"));
			direccion.setDescripcionCastellano(resultSet.getString("DESNESDIREC"));
			direccion.setDescripcionEuskera(resultSet.getString("DESNEUSDIREC"));
			resultadosActuacion.setDireccion(direccion);

			OrigenesInspeccion origenesInspeccion = new OrigenesInspeccion();
			origenesInspeccion.setIdOrigenInspeccion(resultSet.getInt("IDORIGEN"));
			origenesInspeccion.setDescripcionCastellano(resultSet.getString("DESNESORIGEN"));
			origenesInspeccion.setDescripcionEuskera(resultSet.getString("DESNEUSORIGEN"));
			resultadosActuacion.setOrigenesInspeccion(origenesInspeccion);

			DesResAct desResAct = new DesResAct();
			desResAct.setIdDesResAct(resultSet.getInt("IDDESRESACT"));
			desResAct.setDescripcionCastellano(resultSet.getString("RESULACTUACIONDESCCASTELLANO"));
			desResAct.setDescripcionEuskera(resultSet.getString("RESULACTUACIONDESCEUSKERA"));
			resultadosActuacion.setDesResAct(desResAct);

			return resultadosActuacion;
		}
	};

	private RowMapper<ResultadosActuacion> rwMapPK = new RowMapper<ResultadosActuacion>() {
		public ResultadosActuacion mapRow(ResultSet resultSet, int rowNum) throws SQLException {
			return new ResultadosActuacion(resultSet.getLong("IDRESULTADOACTUACION"));
		}
	};

	/**
	 * Rowmapper para Jerarquía
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	private RowMapper<JerarquiaDto<ResultadosActuacion>> rwMapJerarquia = new RowMapper<JerarquiaDto<ResultadosActuacion>>() {
		public JerarquiaDto<ResultadosActuacion> mapRow(ResultSet resultSet, int rowNum) throws SQLException {

			ResultadosActuacion resultadosactuacion = new ResultadosActuacion();
			resultadosactuacion.setIdResultadoActuacion(resultSet.getLong("IDRESULTADOACTUACION"));
			resultadosactuacion.setBaja(resultSet.getInt("BAJA"));
			resultadosactuacion.setFechaRegistro(resultSet.getDate("FECHAREGISTRO"));
			resultadosactuacion.setUsuarioRegistro(resultSet.getString("USUARIOREGISTRO"));

			JerarquiaDto<ResultadosActuacion> jerarquia = new JerarquiaDto<ResultadosActuacion>();
			jerarquia.setModel(resultadosactuacion);
			jerarquia.setLevel(resultSet.getBigDecimal("LEVEL").intValue());
			jerarquia.setParentNodes(resultSet.getString("PARENTNODES"));
			jerarquia.setIsLeaf(Boolean.parseBoolean(resultSet.getString("ISLEAF")));
			jerarquia.setFilter(Boolean.parseBoolean(resultSet.getString("FILTER")));
			return jerarquia;
		}
	};

	/**
	 * Method use to set the datasource.
	 *
	 * @param dataSource
	 *            DataSource
	 * @return
	 */
	@Resource
	public void setDataSource(DataSource dataSource) {
		this.jdbcTemplate = new JdbcTemplate(dataSource);
	}

	/*
	 * OPERACIONES CRUD
	 */

	/**
	 * Inserts a single row in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @return ResultadosActuacion
	 */
	public ResultadosActuacion add(ResultadosActuacion resultadosactuacion) {

		int idResultadoActuacion = this.jdbcTemplate.queryForObject("SELECT AB79.S_AB7916T00.NEXTVAL FROM DUAL",
				Integer.class);

		String query = "INSERT INTO RESULTADOS_ACTUACION (ID_RESULTADO_ACTUACION, BAJA, FECHA_REGISTRO, USUARIO_REGISTRO, ID_ORIGEN_INSPECCION, ID_DIRECCION, ID_DES_RES_ACT) VALUES (?,?,SYSDATE,?,?,?,?)";
		this.jdbcTemplate.update(query, idResultadoActuacion, Constantes.BAJA_NO,
				resultadosactuacion.getUsuarioRegistro(), resultadosactuacion.getIdOrigen(),
				resultadosactuacion.getIdDireccion(), resultadosactuacion.getDesResAct().getIdDesResAct());
		return resultadosactuacion;
	}

	/**
	 * Updates a single row in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @return ResultadosActuacion
	 */
	public ResultadosActuacion update(ResultadosActuacion resultadosactuacion) {
		String query = "UPDATE RESULTADOS_ACTUACION SET ID_ORIGEN_INSPECCION=?, ID_DIRECCION=?, ID_DES_RES_ACT=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_RESULTADO_ACTUACION=?";
		this.jdbcTemplate.update(query, resultadosactuacion.getIdOrigen(), resultadosactuacion.getIdDireccion(),
				resultadosactuacion.getDesResAct().getIdDesResAct(), resultadosactuacion.getUsuarioUltmodificacion(),
				resultadosactuacion.getIdResultadoActuacion());
		return resultadosactuacion;
	}

	/**
	 * Finds a single row in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @return ResultadosActuacion
	 */
	@Transactional(readOnly = true)
	public ResultadosActuacion find(ResultadosActuacion resultadosactuacion) {
		String query = "SELECT t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION, t1.BAJA BAJA, t1.FECHA_REGISTRO FECHAREGISTRO, t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_CASTELLANO DESNESORIGEN,t2.DESCRIPCION_EUSKERA DESNEUSORIGEN, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.DESCRIPCION_CASTELLANO DESNESDIREC, t4.ID_DES_RES_ACT IDDESRESACT, t4.DESCRIPCION_CASTELLANO RESULACTUACIONDESCCASTELLANO, t4.DESCRIPCION_EUSKERA RESULACTUACIONDESCEUSKERA FROM RESULTADOS_ACTUACION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_ACT t4  WHERE t1.ID_RESULTADO_ACTUACION = ? AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_ACT = t4.ID_DES_RES_ACT  ";

		List<ResultadosActuacion> resultadosactuacionList = this.jdbcTemplate.query(query, this.rwMapFindAll,
				resultadosactuacion.getIdResultadoActuacion());
		return (ResultadosActuacion) DataAccessUtils.uniqueResult(resultadosactuacionList);
	}

	@Override
	public Integer findRegistroDuplicado(ResultadosActuacion resultadoActuacion) {
		String query = "SELECT COUNT(1) FROM RESULTADOS_ACTUACION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_ACT t4 WHERE t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_ACT = t4.ID_DES_RES_ACT AND t2.ID_ORIGEN_INSPECCION = ? AND t3.ID_DIRECCION = ? AND t4.ID_DES_RES_ACT = ? AND t1.BAJA = ?";
		List<Object> params = new ArrayList<Object>();
		params.add(resultadoActuacion.getIdOrigen());
		params.add(resultadoActuacion.getIdDireccion());
		params.add(resultadoActuacion.getDesResAct().getIdDesResAct());
		params.add(Constantes.BAJA_NO);
 
		return this.jdbcTemplate.queryForObject(query, params.toArray(), Integer.class);
	}

	/**
	 * Removes a single row in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @return
	 */
	public void remove(ResultadosActuacion resultadosactuacion) {
		String query = "UPDATE RESULTADOS_ACTUACION SET BAJA=?, FECHA_ULTMODIFICACION=sysdate, USUARIO_ULTMODIFICACION=? WHERE ID_RESULTADO_ACTUACION=?";
		this.jdbcTemplate.update(query, Constantes.BAJA_SI, resultadosactuacion.getUsuarioUltmodificacion(),
				resultadosactuacion.getIdResultadoActuacion());
	}

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	public List<ResultadosActuacion> getMultiple(ResultadosActuacion filterResultadosActuacion,
			TableRequestDto tableRequestDto, Boolean startsWith) {

		// Where clause & Params
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterResultadosActuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbMultipleSQL = TableManager.getSelectMultipleQuery(tableRequestDto, ResultadosActuacion.class,
				params, "ID_RESULTADO_ACTUACION");

		return this.jdbcTemplate.query(sbMultipleSQL.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds a list of rows in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<ResultadosActuacion>
	 */
	@Transactional(readOnly = true)
	public List<ResultadosActuacion> findAll(ResultadosActuacion resultadosactuacion, TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t3.ID_DES_RES_ACT IDDESRESACT, t3.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t3.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA");
		query.append(", t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_DIRECCION IDDIRECCION");
		query.append(" FROM RESULTADOS_ACTUACION t1, INSPECCIONES t2, DES_RES_ACT t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(resultadosactuacion);
		StringBuilder where = new StringBuilder(
				" WHERE t1.ID_DIRECCION = t2.ID_DIRECCION AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DES_RES_ACT = t3.ID_DES_RES_ACT ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		// if (tableRequestDto != null) {
		// query = TableManager.getPaginationQuery(tableRequestDto, query,
		// ResultadosActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		return (List<ResultadosActuacion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	@Override
	public List<ResultadosActuacion> findAllREST(ResultadosActuacion filterResultadosActuacion,
			TableRequestDto tableRequestDto) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t2.ID_DES_RES_ACT IDDESRESACT, t2.DESCRIPCION_CASTELLANO RESULDESCRIPCIONCASTELLANO, t2.DESCRIPCION_EUSKERA RESULDESCRIPCIONEUSKERA");
		query.append(", t1.ID_ORIGEN_INSPECCION IDORIGENINSPECCION, t1.ID_DIRECCION IDDIRECCION");
		query.append(" FROM RESULTADOS_ACTUACION t1, DES_RES_ACT t2 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(filterResultadosActuacion);
		StringBuilder where = new StringBuilder(" WHERE t1.ID_DES_RES_ACT = t2.ID_DES_RES_ACT");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		// if (tableRequestDto != null) {
		// query = TableManager.getPaginationQuery(tableRequestDto, query,
		// ResultadosActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		return (List<ResultadosActuacion>) this.jdbcTemplate.query(query.toString(), this.rwMap, params.toArray());
	}

	/**
	 * Finds rows in the ResultadosActuacion table using like.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<ResultadosActuacion>
	 */
	@Transactional(readOnly = true)
	public List<ResultadosActuacion> findAllLike(ResultadosActuacion resultadosactuacion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT  t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACION,t1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO, t1.FECHA_ULTMODIFICACION FECHAULTMODIFICACION, t1.USUARIO_ULTMODIFICACION USUARIOULTMODIFICACION, t2.DESCRIPCION_EUSKERA DESNEUSORIGEN, t2.ID_ORIGEN_INSPECCION IDORIGEN, t2.DESCRIPCION_CASTELLANO DESNESORIGEN, t3.ID_DIRECCION IDDIRECCION, t3.DESCRIPCION_EUSKERA DESNEUSDIREC, t3.DESCRIPCION_CASTELLANO DESNESDIREC, t4.ID_DES_RES_ACT IDDESRESACT, t4.DESCRIPCION_CASTELLANO RESULACTUACIONDESCCASTELLANO, t4.DESCRIPCION_EUSKERA RESULACTUACIONDESCEUSKERA ");
		query.append("FROM RESULTADOS_ACTUACION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_ACT t4 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMapFindAll(resultadosactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1 = 1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		if (tableRequestDto != null) {
			query = TableManager.getPaginationQuery(tableRequestDto, query);
		}

		return (List<ResultadosActuacion>) this.jdbcTemplate.query(query.toString(), this.rwMapFindAll,
				params.toArray());
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Counts rows in the ResultadosActuacion table.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllCount(ResultadosActuacion resultadosactuacion) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM RESULTADOS_ACTUACION t1, INSPECCIONES t2, DES_RES_ACT t3 ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereMap(resultadosactuacion);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Counts rows in the ResultadosActuacion table using like.
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	@Transactional(readOnly = true)
	public Long findAllLikeCount(ResultadosActuacion resultadosactuacion, Boolean startsWith) {
		StringBuilder query = new StringBuilder(
				"SELECT COUNT(1) FROM RESULTADOS_ACTUACION t1, ORIGENES_INSPECCION t2, DIRECCIONES t3, DES_RES_ACT t4  ");

		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMapFindAll(resultadosactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Reorder the data list of ResultadosActuacion selected for rup_table
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ResultadosActuacion>>
	 */
	@Override
	public List<TableRowDto<ResultadosActuacion>> reorderSelection(ResultadosActuacion resultadosactuacion,
			TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACIONt1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_ACTUACION t1 ");
		// FILTRADO
		// Where clause & Params
		Map<String, ?> mapaWhere = this.getWhereLikeMap(resultadosactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		// Parámetros de filtrado
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhere.get("params");

		// SQL para la reordenación
		StringBuilder sbReorderSelectionSQL = TableManager.getReorderQuery(query, tableRequestDto,
				ResultadosActuacion.class, filterParamList, "ID_RESULTADO_ACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ResultadosActuacion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Search method for rup_table
	 *
	 * @param filterParams
	 *            ResultadosActuacion
	 * @param searchParams
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<ResultadosActuacion>>
	 */
	@Override
	public List<TableRowDto<ResultadosActuacion>> search(ResultadosActuacion filterParams,
			ResultadosActuacion searchParams, TableRequestDto tableRequestDto, Boolean startsWith) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACIONt1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_ACTUACION t1 ");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// FILTRADO
		Map<String, ?> mapaWhereFilter = this.getWhereLikeMap(filterParams, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhereFilter.get("query"));
		query.append(where);
		// Filter params
		@SuppressWarnings("unchecked")
		List<Object> filterParamList = (List<Object>) mapaWhereFilter.get("params");

		// BUSQUEDA
		Map<String, Object> mapaWhereSearch = this.getWhereLikeMap(searchParams, startsWith);
		String searchSQL = ((StringBuilder) mapaWhereSearch.get("query")).toString();
		// Search params
		@SuppressWarnings("unchecked")
		List<Object> searchParamList = (List<Object>) mapaWhereSearch.get("params");

		// SQL
		StringBuilder sbReorderSelectionSQL = TableManager.getSearchQuery(query, tableRequestDto,
				ResultadosActuacion.class, filterParamList, searchSQL, searchParamList, from_alias,
				"ID_RESULTADO_ACTUACION");

		return this.jdbcTemplate.query(sbReorderSelectionSQL.toString(),
				new RowNumResultSetExtractor<ResultadosActuacion>(this.rwMapPK, tableRequestDto),
				filterParamList.toArray());
	}

	/**
	 * Remove multiple method for rup_table
	 *
	 * @param filterresultadosactuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	@Override
	public void removeMultiple(ResultadosActuacion filterresultadosactuacion, TableRequestDto tableRequestDto,
			Boolean startsWith) {
		// SELECT
		/** TODO: select por clave */
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACIONt1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		query.append("FROM RESULTADOS_ACTUACION t1 ");

		// WHERE
		Map<String, Object> mapaWhere = this.getWhereLikeMap(filterresultadosactuacion, startsWith);
		StringBuilder where = new StringBuilder(" WHERE 1=1 ");
		where.append(mapaWhere.get("query"));
		query.append(where);

		@SuppressWarnings("unchecked")
		List<Object> params = (List<Object>) mapaWhere.get("params");

		StringBuilder sbRemoveMultipleSQL = TableManager.getRemoveMultipleQuery(tableRequestDto,
				ResultadosActuacion.class, query, params, "ID_RESULTADO_ACTUACION");
		this.jdbcTemplate.update(sbRemoveMultipleSQL.toString(), params.toArray());
	}

	/**
	 * Filter in the hierarchical ResultadosActuacion table.
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<ResultadosActuacion>>
	 */
	@Override
	public List<JerarquiaDto<ResultadosActuacion>> findAllLikeJerarquia(ResultadosActuacion filterResultadosActuacion,
			TableRequestDto tableRequestDto) {
		// SELECT
		StringBuilder query = new StringBuilder(
				"SELECT t1.ID_RESULTADO_ACTUACION IDRESULTADOACTUACIONt1.BAJA BAJA,t1.FECHA_REGISTRO FECHAREGISTRO,t1.USUARIO_REGISTRO USUARIOREGISTRO ");
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_ACTUACION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_ACTUACION");
		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosActuacion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		query = TableManagerJerarquia.getQuery(tableRequestDto, query, mapaWhere, "ID_RESULTADO_ACTUACION", "ID_PADRE",
				"NOMBRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// query = TableManagerJerarquia.getQuery(tableRequestDto, query,
		// mapaWhere, "ID", "ID_PADRE", "NOMBRE", from, from_alias, joins,
		// businessFilters, businessParams);

		// PAGINACION
		// if (tableRequestDto != null) {
		// query = TableManagerJerarquia.getPaginationQuery(tableRequestDto,
		// query, ResultadosActuacionDaoImpl.ORDER_BY_WHITE_LIST);
		// }

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.query(query.toString(), this.rwMapJerarquia, params.toArray());
	}

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	@Override
	public Long findAllLikeCountJerarquia(ResultadosActuacion filterResultadosActuacion,
			TableRequestDto tableRequestDto) {
		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_ACTUACION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_ACTUACION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosActuacion, false);

		// JERARQUIA
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID_RESULTADO_ACTUACION",
				"ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryCount(tableRequestDto, mapaWhere, "ID",
		// "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");
		return this.jdbcTemplate.queryForObject(query.toString(), params.toArray(), Long.class);
	}

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterResultadosActuacion
	 *            ResultadosActuacion
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<ResultadosActuacion>>
	 */
	@Override
	public List<TableRowDto<ResultadosActuacion>> findAllChild(ResultadosActuacion filterResultadosActuacion,
			TableRequestDto tableRequestDto) {

		// FROM
		// StringBuilder from = new StringBuilder("FROM RESULTADOS_ACTUACION t1
		// ");
		List<String> from = new ArrayList<String>();
		from.add("RESULTADOS_ACTUACION");

		// TABLAS_ALIAS
		List<String> from_alias = new ArrayList<String>();
		from_alias.add(" t1 ");

		// JOINS TABLAS
		/*
		 * Ejemplo de como indicar joins entre las tablas de la query
		 */
		/*
		 * StringBuilder joins = new StringBuilder("");
		 * joins.append("AND T1.ID=T2.ID_T1");
		 */

		// CONDICIONES (negocio)
		/*
		 * Ejemplo de como incluir condiciones de negocio en la consulta de la
		 * jerarquía
		 */
		/*
		 * StringBuilder businessFilters = new StringBuilder(); List<Object>
		 * businessParams = new ArrayList<Object>();
		 * businessFilters.append("   AND t1.EJIE = ?  ");
		 * businessParams.add("1");
		 */

		// FILTRO
		Map<String, ?> mapaWhere = this.getWhereLikeMap(filterResultadosActuacion, false);

		// MULTISELECCION
		// Especificar la columna padre correspondiente en lugar de la generada
		// por defecto (ID_PADRE)
		StringBuilder query = TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
				"ID_RESULTADO_ACTUACION", "ID_PADRE", from, from_alias);

		/*
		 * Ejemplo de llamada en caso de indicar joins entre tablas y
		 * condiciones de negocio
		 */
		// StringBuilder query =
		// TableManagerJerarquia.getQueryChildren(tableRequestDto, mapaWhere,
		// "ID", "ID_PADRE", from, from_alias, joins, businessFilters,
		// businessParams);

		List<?> params = (List<?>) mapaWhere.get("params");

		return this.jdbcTemplate.query(query.toString(),
				new RowNumResultSetExtractor<ResultadosActuacion>(this.rwMapPK, "ID_RESULTADO_ACTUACION"),
				params.toArray());
	}

	/*
	 * MÉTODOS PRIVADOS
	 */

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ResultadosActuacion entity
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion Bean with the criteria values to filter
	 *            by.
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, ?> getWhereMap(ResultadosActuacion resultadosactuacion) {

		StringBuilder where = new StringBuilder(ResultadosActuacionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosactuacion != null && resultadosactuacion.getIdResultadoActuacion() != null) {
			where.append(" AND t1.ID_RESULTADO_ACTUACION = ?");
			params.add(resultadosactuacion.getIdResultadoActuacion());
		}
		if (resultadosactuacion != null && resultadosactuacion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosactuacion.getFechaRegistro());
		}
		if (resultadosactuacion != null && resultadosactuacion.getUsuarioRegistro() != null) {
			where.append(" AND t1.USUARIO_REGISTRO = ?");
			params.add(resultadosactuacion.getUsuarioRegistro());
		}

		if (resultadosactuacion != null && resultadosactuacion.getBaja() != null) {
			where.append(" AND (t1.BAJA = ? OR t1.BAJA IS NULL)");
			params.add(resultadosactuacion.getBaja());
		}

		if (resultadosactuacion != null && resultadosactuacion.getIdInspeccion() != null) {
			where.append(" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t2.ID_INSPECCION = "
					+ resultadosactuacion.getIdInspeccion());
		}
		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * Returns a map with the needed value to create the conditions to filter by
	 * the ResultadosActuacion entity
	 *
	 * @param resultadosactuacion
	 *            ResultadosActuacion Bean with the criteria values to filter
	 *            by.
	 * @param startsWith
	 *            Boolean
	 * @return Map created with two keys key query stores the sql query syntax
	 *         key params stores the parameter values to be used in the
	 *         condition sentence.
	 */
	// CHECKSTYLE:OFF CyclomaticComplexity - Generación de código de UDA
	private Map<String, Object> getWhereLikeMap(ResultadosActuacion resultadosactuacion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ResultadosActuacionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosactuacion != null && resultadosactuacion.getIdResultadoActuacion() != null) {
			where.append(" AND t1.ID_RESULTADO_ACTUACION = ?");
			params.add(resultadosactuacion.getIdResultadoActuacion());
		}
		if (resultadosactuacion != null && resultadosactuacion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosactuacion.getFechaRegistro());
		}
		if (resultadosactuacion != null && resultadosactuacion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(resultadosactuacion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + resultadosactuacion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}

		where.append(" AND (t1.BAJA = 0 OR t1.BAJA IS NULL)");

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}

	private Map<String, Object> getWhereLikeMapFindAll(ResultadosActuacion resultadosactuacion, Boolean startsWith) {

		StringBuilder where = new StringBuilder(ResultadosActuacionDaoImpl.STRING_BUILDER_INIT);
		List<Object> params = new ArrayList<Object>();

		if (resultadosactuacion != null && resultadosactuacion.getIdResultadoActuacion() != null) {
			where.append(" AND t1.ID_RESULTADO_ACTUACION = ?");
			params.add(resultadosactuacion.getIdResultadoActuacion());
		}
		if (resultadosactuacion != null && resultadosactuacion.getFechaRegistro() != null) {
			where.append(" AND t1.FECHA_REGISTRO = ?");
			params.add(resultadosactuacion.getFechaRegistro());
		}
		if (resultadosactuacion != null && resultadosactuacion.getUsuarioRegistro() != null) {
			where.append(" AND UPPER(t1.USUARIO_REGISTRO) like ? ESCAPE  '\\'");
			if (startsWith) {
				params.add(resultadosactuacion.getUsuarioRegistro().toUpperCase() + "%");
			} else {
				params.add("%" + resultadosactuacion.getUsuarioRegistro().toUpperCase() + "%");
			}
			where.append(" AND t1.USUARIO_REGISTRO IS NOT NULL");
		}
		if (resultadosactuacion != null && resultadosactuacion.getDireccion() != null
				&& resultadosactuacion.getDireccion().getIdDireccion() != null) {
			where.append(" AND t1.ID_DIRECCION = ?");
			params.add(resultadosactuacion.getDireccion().getIdDireccion());
		}
		if (resultadosactuacion != null && resultadosactuacion.getIdOrigen() != null) {
			where.append(" AND t1.ID_ORIGEN_INSPECCION = ?");
			params.add(resultadosactuacion.getIdOrigen());
		}
		if (resultadosactuacion != null && resultadosactuacion.getDesResAct() != null
				&& resultadosactuacion.getDesResAct().getIdDesResAct() != null) {
			where.append(" AND t1.ID_DES_RES_ACT = ?");
			params.add(resultadosactuacion.getDesResAct().getIdDesResAct());
		}
		where.append(
				" AND (t1.BAJA = 0 OR t1.BAJA IS NULL) AND t1.ID_ORIGEN_INSPECCION = t2.ID_ORIGEN_INSPECCION AND t1.ID_DIRECCION = t3.ID_DIRECCION AND t1.ID_DES_RES_ACT = t4.ID_DES_RES_ACT");

		Map<String, Object> mapWhere = new HashMap<String, Object>();
		mapWhere.put("query", where);
		mapWhere.put("params", params);

		return mapWhere;
	}
	// CHECKSTYLE:ON CyclomaticComplexity - Generación de código de UDA

	/**
	 * StringBuilder initilization value
	 */
	public static final int STRING_BUILDER_INIT = 4096;
}
